//+------------------------------------------------------------------+
//|                                       ADX BARS              .mq4 |
//|                                              Perky Aint no turkey|
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Perky"
#property  link      "Perky_z@yahoo.com"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Red
#property  indicator_color2  DodgerBlue
//---- input parameters Hi-Lo
extern int Per=3;
extern int CountBars=300;
//---- buffers Hi-Lo
double Up[];
double Down[];

//ADX
//---- indicator parameters
extern int ADXPeriod=14;
//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
//double     ind_buffer3[];
int        HighBarBuffer[];
int        LowBarBuffer[];
double     ArOscBuffer[];
double b4plusdi,b4minusdi,nowplusdi,nowminusdi;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   //----additional buffers are used for counting.
   IndicatorBuffers(2);
/*   IndicatorBuffers(5);
   SetIndexBuffer(2, HighBarBuffer);
   SetIndexBuffer(3, LowBarBuffer);
   SetIndexBuffer(4, ArOscBuffer);
*/
   //---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   //SetIndexDrawBegin(0,1500);
   //SetIndexDrawBegin(1,1500);  
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   
   //---- indicator buffers mapping
   if(!SetIndexBuffer(0,ind_buffer1) && !SetIndexBuffer(1,ind_buffer2))
//   if(!SetIndexBuffer(0,ind_buffer1) && !SetIndexBuffer(1,ind_buffer2)
//   && !SetIndexBuffer(2,HighBarBuffer) && !SetIndexBuffer(3,LowBarBuffer)
//   && !SetIndexBuffer(4,ArOscBuffer))
      Print("cannot set indicator buffers!");
      
   //---- name for DataWindow and indicator subwindow label
   
   //---- initialization done
   return(0);
  }
 
//+------------------------------------------------------------------+
//| Aroon Oscilator                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double   ArOsc=0;
   int      ArPer,limit,i; 
   int      counted_bars=IndicatorCounted();
      //HiLo 
   int i1;
   bool Pr=false, PrevPr=false;
   double val,val2;
   
   
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   if(CountBars<=Per) return(0); //HiLo
   //---- initial zero
   if(counted_bars<1)  //HiLo
   {
      for(i=1;i<=Per;i++) Up[CountBars-i]=0.0;
      for(i=1;i<=Per;i++) Down[CountBars-i]=0.0;
   }  
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   //----Calculation---------------------------
 //  for( i=0; i<limit-2; i++)
    i=CountBars-Per-1;
   while(i>=0)

   {
     nowplusdi = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,i);
     nowminusdi = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,i);

      val=iMA(NULL,0,Per,1,MODE_SMA,PRICE_HIGH,i);//HiLo
      val2=iMA(NULL,0,Per,1,MODE_SMA,PRICE_LOW,i);//HiLo
      if (Close[i]<val2 && PrevPr==true) Pr=false;   
      if (Close[i]>val && PrevPr==false) Pr=true;
      PrevPr=Pr;   
      ind_buffer2[i]=0.0;
      ind_buffer1[i]=0.0;
       
      if(nowminusdi>nowplusdi) 
       { if(Pr==false)
           {
            ind_buffer2[i]=Low[i];
            ind_buffer1[i]=High[i];
           }
       }

      if(nowplusdi>nowminusdi) 
       { if(Pr==true)
           {
            ind_buffer1[i]=Low[i];
            ind_buffer2[i]=High[i];
           } 
       }
      i--;
     }
   //---- done

   return(0);
  }